Index: anches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/CoordinatesPTSPDataView.Designer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/CoordinatesPTSPDataView.Designer.cs	(revision 17335)
+++ 	(revision )
@@ -1,127 +1,0 @@
-﻿namespace HeuristicLab.Problems.PTSP.Views {
-  partial class CoordinatesPTSPDataView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
-      this.coordinatesTabPage = new System.Windows.Forms.TabPage();
-      this.probabilitiesTabPage = new System.Windows.Forms.TabPage();
-      this.probabilitiesView = new HeuristicLab.Data.Views.StringConvertibleArrayView();
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesSplitContainer)).BeginInit();
-      this.coordinatesSplitContainer.Panel1.SuspendLayout();
-      this.coordinatesSplitContainer.Panel2.SuspendLayout();
-      this.coordinatesSplitContainer.SuspendLayout();
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesPictureBox)).BeginInit();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.tabControl.SuspendLayout();
-      this.probabilitiesTabPage.SuspendLayout();
-      this.SuspendLayout();
-      // 
-      // coordinatesSplitContainer
-      // 
-      // 
-      // coordinatesMatrixView
-      // 
-      this.coordinatesMatrixView.ShowStatisticalInformation = false;
-      // 
-      // nameTextBox
-      // 
-      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      // 
-      // tabControl
-      // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.tabControl.Controls.Add(this.coordinatesTabPage);
-      this.tabControl.Controls.Add(this.probabilitiesTabPage);
-      this.tabControl.Location = new System.Drawing.Point(0, 26);
-      this.tabControl.Name = "tabControl";
-      this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(256, 567);
-      this.tabControl.TabIndex = 2;
-      // 
-      // coordinatesTabPage
-      // 
-      this.coordinatesTabPage.Location = new System.Drawing.Point(4, 22);
-      this.coordinatesTabPage.Name = "coordinatesTabPage";
-      this.coordinatesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.coordinatesTabPage.Size = new System.Drawing.Size(248, 541);
-      this.coordinatesTabPage.TabIndex = 0;
-      this.coordinatesTabPage.Text = "Coordinates";
-      this.coordinatesTabPage.UseVisualStyleBackColor = true;
-      // 
-      // probabilitiesTabPage
-      // 
-      this.probabilitiesTabPage.Controls.Add(this.probabilitiesView);
-      this.probabilitiesTabPage.Location = new System.Drawing.Point(4, 22);
-      this.probabilitiesTabPage.Name = "probabilitiesTabPage";
-      this.probabilitiesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.probabilitiesTabPage.Size = new System.Drawing.Size(248, 544);
-      this.probabilitiesTabPage.TabIndex = 1;
-      this.probabilitiesTabPage.Text = "Probabilities";
-      this.probabilitiesTabPage.UseVisualStyleBackColor = true;
-      // 
-      // probabilitiesView
-      // 
-      this.probabilitiesView.Caption = "StringConvertibleArray View";
-      this.probabilitiesView.Content = null;
-      this.probabilitiesView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.probabilitiesView.Location = new System.Drawing.Point(3, 3);
-      this.probabilitiesView.Name = "probabilitiesView";
-      this.probabilitiesView.ReadOnly = false;
-      this.probabilitiesView.Size = new System.Drawing.Size(242, 538);
-      this.probabilitiesView.TabIndex = 0;
-      // 
-      // CoordinatesPTSPDataView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.Controls.Add(this.tabControl);
-      this.Name = "CoordinatesPTSPDataView";
-      this.Controls.SetChildIndex(this.coordinatesSplitContainer, 0);
-      this.Controls.SetChildIndex(this.nameLabel, 0);
-      this.Controls.SetChildIndex(this.nameTextBox, 0);
-      this.Controls.SetChildIndex(this.infoLabel, 0);
-      this.Controls.SetChildIndex(this.tabControl, 0);
-      this.coordinatesSplitContainer.Panel1.ResumeLayout(false);
-      this.coordinatesSplitContainer.Panel2.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesSplitContainer)).EndInit();
-      this.coordinatesSplitContainer.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesPictureBox)).EndInit();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      this.tabControl.ResumeLayout(false);
-      this.probabilitiesTabPage.ResumeLayout(false);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.TabControl tabControl;
-    private System.Windows.Forms.TabPage coordinatesTabPage;
-    private System.Windows.Forms.TabPage probabilitiesTabPage;
-    private Data.Views.StringConvertibleArrayView probabilitiesView;
-  }
-}
Index: anches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/CoordinatesPTSPDataView.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/CoordinatesPTSPDataView.cs	(revision 17335)
+++ 	(revision )
@@ -1,109 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Drawing;
-using System.Windows.Forms;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
-using HeuristicLab.Problems.TravelingSalesman.Views;
-
-namespace HeuristicLab.Problems.PTSP.Views {
-  [View("Coordinates pTSP Data View")]
-  [Content(typeof(CoordinatesPTSPData), IsDefaultView = true)]
-  public partial class CoordinatesPTSPDataView : CoordinatesTSPDataView {
-
-    public new CoordinatesPTSPData Content {
-      get { return (CoordinatesPTSPData)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public CoordinatesPTSPDataView() {
-      InitializeComponent();
-      SuspendLayout();
-      Controls.Remove(coordinatesMatrixView);
-      coordinatesMatrixView.Dock = System.Windows.Forms.DockStyle.None;
-      coordinatesTabPage.Controls.Add(coordinatesMatrixView);
-      coordinatesMatrixView.Dock = System.Windows.Forms.DockStyle.Fill;
-      ResumeLayout(true);
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        probabilitiesView.Content = null;
-      } else {
-        probabilitiesView.Content = Content.Probabilities;
-      }
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      probabilitiesView.Enabled = !ReadOnly && !Locked && Content != null;
-    }
-
-    protected override void GenerateImage() {
-      if ((coordinatesPictureBox.Width > 0) && (coordinatesPictureBox.Height > 0)) {
-        if (Content == null) {
-          coordinatesPictureBox.Image = null;
-        } else {
-          DoubleMatrix coordinates = Content.Coordinates;
-          DoubleArray probabilities = Content.Probabilities;
-          Bitmap bitmap = new Bitmap(coordinatesPictureBox.Width, coordinatesPictureBox.Height);
-
-          if ((coordinates != null) && (coordinates.Rows > 0) && (coordinates.Columns == 2) && (probabilities.Length == coordinates.Rows)) {
-            double xMin = double.MaxValue, yMin = double.MaxValue, xMax = double.MinValue, yMax = double.MinValue;
-            for (int i = 0; i < coordinates.Rows; i++) {
-              if (xMin > coordinates[i, 0]) xMin = coordinates[i, 0];
-              if (yMin > coordinates[i, 1]) yMin = coordinates[i, 1];
-              if (xMax < coordinates[i, 0]) xMax = coordinates[i, 0];
-              if (yMax < coordinates[i, 1]) yMax = coordinates[i, 1];
-            }
-
-            int border = 20;
-            double xStep = xMax != xMin ? (coordinatesPictureBox.Width - 2 * border) / (xMax - xMin) : 1;
-            double yStep = yMax != yMin ? (coordinatesPictureBox.Height - 2 * border) / (yMax - yMin) : 1;
-
-            Point[] points = new Point[coordinates.Rows];
-            for (int i = 0; i < coordinates.Rows; i++)
-              points[i] = new Point(border + ((int)((coordinates[i, 0] - xMin) * xStep)),
-                                    bitmap.Height - (border + ((int)((coordinates[i, 1] - yMin) * yStep))));
-
-            using (Graphics graphics = Graphics.FromImage(bitmap)) {
-              for (int i = 0; i < points.Length; i++)
-                graphics.FillRectangle(Brushes.Red, points[i].X - 2, points[i].Y - 2, Convert.ToInt32(probabilities[i] * 20), Convert.ToInt32(probabilities[i] * 20));
-            }
-          } else {
-            using (Graphics graphics = Graphics.FromImage(bitmap)) {
-              graphics.Clear(Color.White);
-              Font font = new Font(FontFamily.GenericSansSerif, 12, FontStyle.Regular);
-              string text = "No coordinates defined or in wrong format.";
-              SizeF strSize = graphics.MeasureString(text, font);
-              graphics.DrawString(text, font, Brushes.Black, (float)(coordinatesPictureBox.Width - strSize.Width) / 2.0f, (float)(coordinatesPictureBox.Height - strSize.Height) / 2.0f);
-            }
-          }
-          coordinatesPictureBox.Image = bitmap;
-        }
-      }
-    }
-  }
-}
Index: anches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/EuclideanPTSPDataView.Designer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/EuclideanPTSPDataView.Designer.cs	(revision 17335)
+++ 	(revision )
@@ -1,126 +1,0 @@
-﻿namespace HeuristicLab.Problems.PTSP.Views {
-  partial class EuclideanPTSPDataView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
-      this.coordinatesTabPage = new System.Windows.Forms.TabPage();
-      this.probabilitiesTabPage = new System.Windows.Forms.TabPage();
-      this.probabilitiesView = new HeuristicLab.Data.Views.StringConvertibleArrayView();
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesSplitContainer)).BeginInit();
-      this.coordinatesSplitContainer.Panel1.SuspendLayout();
-      this.coordinatesSplitContainer.Panel2.SuspendLayout();
-      this.coordinatesSplitContainer.SuspendLayout();
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesPictureBox)).BeginInit();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.tabControl.SuspendLayout();
-      this.probabilitiesTabPage.SuspendLayout();
-      this.SuspendLayout();
-      // 
-      // coordinatesSplitContainer
-      // 
-      // 
-      // coordinatesSplitContainer.Panel1
-      // 
-      this.coordinatesSplitContainer.Panel1.Controls.Add(this.tabControl);
-      // 
-      // coordinatesMatrixView
-      // 
-      this.coordinatesMatrixView.ShowStatisticalInformation = false;
-      // 
-      // nameTextBox
-      // 
-      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      // 
-      // tabControl
-      // 
-      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.tabControl.Controls.Add(this.coordinatesTabPage);
-      this.tabControl.Controls.Add(this.probabilitiesTabPage);
-      this.tabControl.Location = new System.Drawing.Point(0, 30);
-      this.tabControl.Name = "tabControl";
-      this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(256, 540);
-      this.tabControl.TabIndex = 4;
-      // 
-      // coordinatesTabPage
-      // 
-      this.coordinatesTabPage.Location = new System.Drawing.Point(4, 22);
-      this.coordinatesTabPage.Name = "coordinatesTabPage";
-      this.coordinatesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.coordinatesTabPage.Size = new System.Drawing.Size(248, 514);
-      this.coordinatesTabPage.TabIndex = 0;
-      this.coordinatesTabPage.Text = "Coordinates";
-      this.coordinatesTabPage.UseVisualStyleBackColor = true;
-      // 
-      // probabilitiesTabPage
-      // 
-      this.probabilitiesTabPage.Controls.Add(this.probabilitiesView);
-      this.probabilitiesTabPage.Location = new System.Drawing.Point(4, 22);
-      this.probabilitiesTabPage.Name = "probabilitiesTabPage";
-      this.probabilitiesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.probabilitiesTabPage.Size = new System.Drawing.Size(248, 514);
-      this.probabilitiesTabPage.TabIndex = 1;
-      this.probabilitiesTabPage.Text = "Probabilities";
-      this.probabilitiesTabPage.UseVisualStyleBackColor = true;
-      // 
-      // probabilitiesView
-      // 
-      this.probabilitiesView.Caption = "StringConvertibleArray View";
-      this.probabilitiesView.Content = null;
-      this.probabilitiesView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.probabilitiesView.Location = new System.Drawing.Point(3, 3);
-      this.probabilitiesView.Name = "probabilitiesView";
-      this.probabilitiesView.ReadOnly = false;
-      this.probabilitiesView.Size = new System.Drawing.Size(242, 508);
-      this.probabilitiesView.TabIndex = 0;
-      // 
-      // EuclideanPTSPDataView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.Name = "EuclideanPTSPDataView";
-      this.coordinatesSplitContainer.Panel1.ResumeLayout(false);
-      this.coordinatesSplitContainer.Panel1.PerformLayout();
-      this.coordinatesSplitContainer.Panel2.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesSplitContainer)).EndInit();
-      this.coordinatesSplitContainer.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesPictureBox)).EndInit();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      this.tabControl.ResumeLayout(false);
-      this.probabilitiesTabPage.ResumeLayout(false);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.TabControl tabControl;
-    private System.Windows.Forms.TabPage coordinatesTabPage;
-    private System.Windows.Forms.TabPage probabilitiesTabPage;
-    private Data.Views.StringConvertibleArrayView probabilitiesView;
-  }
-}
Index: anches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/EuclideanPTSPDataView.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/EuclideanPTSPDataView.cs	(revision 17335)
+++ 	(revision )
@@ -1,107 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Drawing;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-using HeuristicLab.Problems.TravelingSalesman.Views;
-
-namespace HeuristicLab.Problems.PTSP.Views {
-  [View("Euclidean TSP Data View")]
-  [Content(typeof(EuclideanPTSPData), IsDefaultView = true)]
-  public partial class EuclideanPTSPDataView : EuclideanTSPDataView {
-
-    public new EuclideanPTSPData Content {
-      get { return (EuclideanPTSPData)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public EuclideanPTSPDataView() {
-      InitializeComponent();
-      SuspendLayout();
-      Controls.Remove(coordinatesMatrixView);
-      coordinatesMatrixView.Dock = System.Windows.Forms.DockStyle.None;
-      coordinatesTabPage.Controls.Add(coordinatesMatrixView);
-      coordinatesMatrixView.Dock = System.Windows.Forms.DockStyle.Fill;
-      ResumeLayout(true);
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        probabilitiesView.Content = null;
-      } else {
-        probabilitiesView.Content = Content.Probabilities;
-      }
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      probabilitiesView.Enabled = !ReadOnly && !Locked && Content != null;
-    }
-
-    protected override void GenerateImage() {
-      if ((coordinatesPictureBox.Width > 0) && (coordinatesPictureBox.Height > 0)) {
-        if (Content == null) {
-          coordinatesPictureBox.Image = null;
-        } else {
-          DoubleMatrix coordinates = Content.Coordinates;
-          DoubleArray probabilities = Content.Probabilities;
-          Bitmap bitmap = new Bitmap(coordinatesPictureBox.Width, coordinatesPictureBox.Height);
-
-          if ((coordinates != null) && (coordinates.Rows > 0) && (coordinates.Columns == 2) && (probabilities.Length == coordinates.Rows)) {
-            double xMin = double.MaxValue, yMin = double.MaxValue, xMax = double.MinValue, yMax = double.MinValue;
-            for (int i = 0; i < coordinates.Rows; i++) {
-              if (xMin > coordinates[i, 0]) xMin = coordinates[i, 0];
-              if (yMin > coordinates[i, 1]) yMin = coordinates[i, 1];
-              if (xMax < coordinates[i, 0]) xMax = coordinates[i, 0];
-              if (yMax < coordinates[i, 1]) yMax = coordinates[i, 1];
-            }
-
-            int border = 20;
-            double xStep = xMax != xMin ? (coordinatesPictureBox.Width - 2 * border) / (xMax - xMin) : 1;
-            double yStep = yMax != yMin ? (coordinatesPictureBox.Height - 2 * border) / (yMax - yMin) : 1;
-
-            Point[] points = new Point[coordinates.Rows];
-            for (int i = 0; i < coordinates.Rows; i++)
-              points[i] = new Point(border + ((int)((coordinates[i, 0] - xMin) * xStep)),
-                                    bitmap.Height - (border + ((int)((coordinates[i, 1] - yMin) * yStep))));
-
-            using (Graphics graphics = Graphics.FromImage(bitmap)) {
-              for (int i = 0; i < points.Length; i++)
-                graphics.FillRectangle(Brushes.Red, points[i].X - 2, points[i].Y - 2, Convert.ToInt32(probabilities[i] * 20), Convert.ToInt32(probabilities[i] * 20));
-            }
-          } else {
-            using (Graphics graphics = Graphics.FromImage(bitmap)) {
-              graphics.Clear(Color.White);
-              Font font = new Font(FontFamily.GenericSansSerif, 12, FontStyle.Regular);
-              string text = "No coordinates defined or in wrong format.";
-              SizeF strSize = graphics.MeasureString(text, font);
-              graphics.DrawString(text, font, Brushes.Black, (float)(coordinatesPictureBox.Width - strSize.Width) / 2.0f, (float)(coordinatesPictureBox.Height - strSize.Height) / 2.0f);
-            }
-          }
-          coordinatesPictureBox.Image = bitmap;
-        }
-      }
-    }
-  }
-}
Index: anches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/MatrixPTSPDataView.Designer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/MatrixPTSPDataView.Designer.cs	(revision 17335)
+++ 	(revision )
@@ -1,119 +1,0 @@
-﻿namespace HeuristicLab.Problems.PTSP.Views {
-  partial class MatrixPTSPDataView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.probabilitiesTabPage = new System.Windows.Forms.TabPage();
-      this.probabilitiesView = new HeuristicLab.Data.Views.StringConvertibleArrayView();
-      this.tabControl.SuspendLayout();
-      this.coordinatesTabPage.SuspendLayout();
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesSplitContainer)).BeginInit();
-      this.coordinatesSplitContainer.Panel1.SuspendLayout();
-      this.coordinatesSplitContainer.Panel2.SuspendLayout();
-      this.coordinatesSplitContainer.SuspendLayout();
-      this.distancesTabPage.SuspendLayout();
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesPictureBox)).BeginInit();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-      this.probabilitiesTabPage.SuspendLayout();
-      this.SuspendLayout();
-      // 
-      // distanceMatrixView
-      // 
-      this.distanceMatrixView.ShowStatisticalInformation = false;
-      // 
-      // tabControl
-      // 
-      this.tabControl.Controls.Add(this.probabilitiesTabPage);
-      this.tabControl.Controls.SetChildIndex(this.probabilitiesTabPage, 0);
-      this.tabControl.Controls.SetChildIndex(this.coordinatesTabPage, 0);
-      this.tabControl.Controls.SetChildIndex(this.distancesTabPage, 0);
-      // 
-      // coordinatesTabPage
-      // 
-      this.coordinatesTabPage.Size = new System.Drawing.Size(763, 544);
-      // 
-      // coordinatesSplitContainer
-      // 
-      this.coordinatesSplitContainer.Size = new System.Drawing.Size(757, 538);
-      // 
-      // coordinatesMatrixView
-      // 
-      this.coordinatesMatrixView.ShowStatisticalInformation = false;
-      this.coordinatesMatrixView.Size = new System.Drawing.Size(252, 538);
-      // 
-      // coordinatesPictureBox
-      // 
-      this.coordinatesPictureBox.Size = new System.Drawing.Size(501, 538);
-      // 
-      // nameTextBox
-      // 
-      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      // 
-      // probabilitiesTabPage
-      // 
-      this.probabilitiesTabPage.Controls.Add(this.probabilitiesView);
-      this.probabilitiesTabPage.Location = new System.Drawing.Point(4, 22);
-      this.probabilitiesTabPage.Name = "probabilitiesTabPage";
-      this.probabilitiesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.probabilitiesTabPage.Size = new System.Drawing.Size(763, 544);
-      this.probabilitiesTabPage.TabIndex = 2;
-      this.probabilitiesTabPage.Text = "Probabilities";
-      this.probabilitiesTabPage.UseVisualStyleBackColor = true;
-      // 
-      // probabilitiesView
-      // 
-      this.probabilitiesView.Caption = "StringConvertibleArray View";
-      this.probabilitiesView.Content = null;
-      this.probabilitiesView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.probabilitiesView.Location = new System.Drawing.Point(3, 3);
-      this.probabilitiesView.Name = "probabilitiesView";
-      this.probabilitiesView.ReadOnly = false;
-      this.probabilitiesView.Size = new System.Drawing.Size(757, 538);
-      this.probabilitiesView.TabIndex = 0;
-      // 
-      // MatrixPTSPDataView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.Name = "MatrixPTSPDataView";
-      this.tabControl.ResumeLayout(false);
-      this.coordinatesTabPage.ResumeLayout(false);
-      this.coordinatesSplitContainer.Panel1.ResumeLayout(false);
-      this.coordinatesSplitContainer.Panel2.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesSplitContainer)).EndInit();
-      this.coordinatesSplitContainer.ResumeLayout(false);
-      this.distancesTabPage.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.coordinatesPictureBox)).EndInit();
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-      this.probabilitiesTabPage.ResumeLayout(false);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.TabPage probabilitiesTabPage;
-    private Data.Views.StringConvertibleArrayView probabilitiesView;
-  }
-}
Index: anches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/MatrixPTSPDataView.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP.Views/3.3/MatrixPTSPDataView.cs	(revision 17335)
+++ 	(revision )
@@ -1,103 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Drawing;
-using System.Windows.Forms;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
-using HeuristicLab.Problems.TravelingSalesman.Views;
-
-namespace HeuristicLab.Problems.PTSP.Views {
-  [View("Matrix pTSP Data View")]
-  [Content(typeof(MatrixPTSPData), IsDefaultView = true)]
-  public partial class MatrixPTSPDataView : MatrixTSPDataView {
-
-    public new MatrixPTSPData Content {
-      get { return (MatrixPTSPData)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public MatrixPTSPDataView() {
-      InitializeComponent();
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        probabilitiesView.Content = null;
-      } else {
-        probabilitiesView.Content = Content.Probabilities;
-      }
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      probabilitiesView.Enabled = !ReadOnly && !Locked && Content != null;
-    }
-
-    protected override void GenerateImage() {
-      if ((coordinatesPictureBox.Width > 0) && (coordinatesPictureBox.Height > 0)) {
-        if (Content == null) {
-          coordinatesPictureBox.Image = null;
-        } else {
-          DoubleMatrix coordinates = Content.DisplayCoordinates;
-          DoubleArray probabilities = Content.Probabilities;
-          Bitmap bitmap = new Bitmap(coordinatesPictureBox.Width, coordinatesPictureBox.Height);
-
-          if ((coordinates != null) && (coordinates.Rows > 0) && (coordinates.Columns == 2) && (probabilities.Length == coordinates.Rows)) {
-            double xMin = double.MaxValue, yMin = double.MaxValue, xMax = double.MinValue, yMax = double.MinValue;
-            for (int i = 0; i < coordinates.Rows; i++) {
-              if (xMin > coordinates[i, 0]) xMin = coordinates[i, 0];
-              if (yMin > coordinates[i, 1]) yMin = coordinates[i, 1];
-              if (xMax < coordinates[i, 0]) xMax = coordinates[i, 0];
-              if (yMax < coordinates[i, 1]) yMax = coordinates[i, 1];
-            }
-
-            int border = 20;
-            double xStep = xMax != xMin ? (coordinatesPictureBox.Width - 2 * border) / (xMax - xMin) : 1;
-            double yStep = yMax != yMin ? (coordinatesPictureBox.Height - 2 * border) / (yMax - yMin) : 1;
-
-            Point[] points = new Point[coordinates.Rows];
-            for (int i = 0; i < coordinates.Rows; i++)
-              points[i] = new Point(border + ((int)((coordinates[i, 0] - xMin) * xStep)),
-                                    bitmap.Height - (border + ((int)((coordinates[i, 1] - yMin) * yStep))));
-
-            using (Graphics graphics = Graphics.FromImage(bitmap)) {
-              for (int i = 0; i < points.Length; i++)
-                graphics.FillRectangle(Brushes.Red, points[i].X - 2, points[i].Y - 2, Convert.ToInt32(probabilities[i] * 20), Convert.ToInt32(probabilities[i] * 20));
-            }
-          } else {
-            using (Graphics graphics = Graphics.FromImage(bitmap)) {
-              graphics.Clear(Color.White);
-              Font font = new Font(FontFamily.GenericSansSerif, 12, FontStyle.Regular);
-              string text = "No coordinates defined or in wrong format.";
-              SizeF strSize = graphics.MeasureString(text, font);
-              graphics.DrawString(text, font, Brushes.Black, (float)(coordinatesPictureBox.Width - strSize.Width) / 2.0f, (float)(coordinatesPictureBox.Height - strSize.Height) / 2.0f);
-            }
-          }
-          coordinatesPictureBox.Image = bitmap;
-        }
-      }
-    }
-  }
-}